// Create an overlay mask with the motion vectors

// See legal notice in Copying.txt for more information

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

#ifndef __MASKFUN__
#define __MASKFUN__

#include "MVInterface.h"

void MakeVectorOcclusionMaskTime(MVClip &mvClip, int nBlkX, int nBlkY, double dMaskNormDivider, double fGamma, int nPel, BYTE * occMask, int occMaskPitch, int time256, int nBlkStepX, int nBlkStepY);
void MakeSADMaskTime(MVClip &mvClip, int nBlkX, int nBlkY, double dMaskNormDivider, double fGamma, int nPel, BYTE * Mask, int MaskPitch, int time256, int nBlkStepX, int nBlkStepY);

void MakeVectorSmallMasks(MVClip &mvClip, int nX, int nY, short *VXSmallY, int pitchVXSmallY, short *VYSmallY, int pitchVYSmallY);
void VectorSmallMaskYToHalfUV(short * VSmallY, int nBlkX, int nBlkY, short *VSmallUV, int ratioUV);

void Merge4PlanesToBig(BYTE *pel2Plane, int pel2Pitch, const BYTE *pPlane0, const BYTE *pPlane1,
					  const BYTE *pPlane2, const BYTE * pPlane3, int width, int height, int pitch, bool isse);

void Merge16PlanesToBig(BYTE *pel4Plane, int pel4Pitch,
                    const BYTE *pPlane0, const BYTE *pPlane1, const BYTE *pPlane2, const BYTE * pPlane3,
                    const BYTE *pPlane4, const BYTE *pPlane5, const BYTE *pPlane6, const BYTE * pPlane7,
                    const BYTE *pPlane8, const BYTE *pPlane9, const BYTE *pPlane10, const BYTE * pPlane11,
                    const BYTE *pPlane12, const BYTE * pPlane13, const BYTE *pPlane14, const BYTE * pPlane15,
					int width, int height, int pitch, bool isse);

unsigned char SADToMask(unsigned int sad, unsigned int sadnorm1024);

void Blend(BYTE * pdst, const BYTE * psrc, const BYTE * pref, int height, int width, int dst_pitch, int src_pitch, int ref_pitch, int time256, bool isse);

void FlowInterSimple(BYTE * pdst, int dst_pitch, const BYTE *prefB, const BYTE *prefF, int ref_pitch,
			   short *VXFullB, short *VXFullF, short *VYFullB, short *VYFullF, BYTE *MaskB, BYTE *MaskF,
			   int VPitch, int width, int height, int time256, int nPel);

void FlowInter(BYTE * pdst, int dst_pitch, const BYTE *prefB, const BYTE *prefF, int ref_pitch,
			   short *VXFullB, short *VXFullF, short *VYFullB, short *VYFullF, BYTE *MaskB, BYTE *MaskF,
			   int VPitch, int width, int height, int time256, int nPel);

void FlowInterExtra(BYTE * pdst, int dst_pitch, const BYTE *prefB, const BYTE *prefF, int ref_pitch,
			   short *VXFullB, short *VXFullF, short *VYFullB, short *VYFullF, BYTE *MaskB, BYTE *MaskF,
			   int VPitch, int width, int height, int time256, int nPel,
			   short *VXFullBB, short *VXFullFF, short *VYFullBB, short *VYFullFF);

#endif
